package org.nakedobjects.nos.remote;

import org.nakedobjects.noa.security.SessionManager;
import org.nakedobjects.noa.security.AuthenticationRequest;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nof.core.security.PasswordAuthenticationRequest;
import org.nakedobjects.nof.reflect.remote.data.Distribution;


public class ProxyAuthenticationManager implements SessionManager {
    private final Distribution connection;

    public ProxyAuthenticationManager(final Distribution connection) {
        this.connection = connection;
    }

    public Session authenticate(AuthenticationRequest request) {
        PasswordAuthenticationRequest passwordRequest = (PasswordAuthenticationRequest) request;
        String username = passwordRequest.getName();
        if (username == null || username.equals("")) {
            return null;
        }
        String password = passwordRequest.getPassword();
        if (password == null || password.equals("")) {
            return null;
        }

        return connection.authenticate(username + "::" + password);
    }

    public void closeSession(Session session) {
        connection.closeSession(session);
        NakedObjectsContext.closeSession();
    }

    public void init() {}

}

// Copyright (c) Naked Objects Group Ltd.
