package org.nakedobjects.nos.remote.command;

import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.util.ByteDecoder;
import org.nakedobjects.noa.util.ByteEncoder;
import org.nakedobjects.nof.core.util.ToString;
import org.nakedobjects.nof.reflect.remote.data.Distribution;


public class HasInstances extends AbstractRequest {
    private static final long serialVersionUID = 1L;
    private final String name;

    public HasInstances(final Session session, final String name) {
        super(session);
        this.name = name;
    }

    public HasInstances(ByteDecoder decoder) {
        super(decoder);
        name = decoder.getString();
    }

    protected void doEncode(final ByteEncoder encoder) {
        encoder.add(name);
    }
    
    public void execute(final Distribution distribution) {
        boolean hasInstances = distribution.hasInstances(session, name);
        setResponse(new Boolean(hasInstances));
    }

    public boolean getFlag() {
        return ((Boolean) response).booleanValue();
    }

    public String toString() {
        ToString str = new ToString(this);
        str.append("class", name);
        return str.toString();
    }
}
// Copyright (c) Naked Objects Group Ltd.
