package org.nakedobjects.nos.remote.command.marshal;

import org.nakedobjects.noa.adapter.Naked;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.persist.InstancesCriteria;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.persist.PatternCriteria;
import org.nakedobjects.nof.reflect.remote.data.CriteriaData;
import org.nakedobjects.nof.reflect.remote.data.KnownObjects;
import org.nakedobjects.nof.reflect.remote.data.ObjectData;
import org.nakedobjects.nof.reflect.remote.data.ObjectEncoder;
import org.nakedobjects.nos.remote.command.java.JavaPatternCriteriaData;


public class PatternCriteriaEncoder extends AbstractCriteriaEncoder {

    public CriteriaData createData(final InstancesCriteria criteria, final ObjectEncoder encoder) {
        PatternCriteria patternCriteria = (PatternCriteria) criteria;
        NakedObject pattern = patternCriteria.getPattern();
        ObjectData objectData = (ObjectData) encoder.createParameters(
                new NakedObjectSpecification[] { pattern.getSpecification() }, new Naked[] { pattern }, new KnownObjects())[0];
        return new JavaPatternCriteriaData(patternCriteria, objectData);
    }

    protected InstancesCriteria doRestore(
            final NakedObjectSpecification specification,
            final boolean includeSubclasses,
            final CriteriaData criteriaData,
            final ObjectEncoder encoder) {
        ObjectData patternData = ((JavaPatternCriteriaData) criteriaData).getPattern();
        NakedObject patternObject = (NakedObject) encoder.restore(patternData);
        return new PatternCriteria(specification, includeSubclasses, patternObject);
    }

    public Class getCriteriaClass() {
        return PatternCriteria.class;
    }
}

// Copyright (c) Naked Objects Group Ltd.
